void TCN_Config(void)
{
	TWBR=0xff;		//set frequency to 375 kHZ
	TWCR=0x44;
	TWSR=TWSR & 0xFC;
	TCN_raddr=0b10010001;
	TCN_waddr=0b10010000;
	//TWSR=TWSR | 0x01;
}

void I2Cdev_sel(int addr)
{
	switch(addr)
		{
		case 1 :TCN_raddr=TCN_raddr ;
				TCN_waddr=TCN_waddr ;
			break ;
		case 2: TCN_raddr=TCN_raddr| 0b00000010;
				TCN_waddr=TCN_waddr| 0b00000010;
			break ;
		case 3: TCN_raddr=TCN_raddr| 0b00000100;
				TCN_waddr=TCN_waddr| 0b00000100;
			break ;
		case 4: TCN_raddr=TCN_raddr| 0b00000110;
				TCN_waddr=TCN_waddr| 0b00000110;
			break ;
		case 5 :TCN_raddr=TCN_raddr| 0b00001000;
				TCN_waddr=TCN_waddr| 0b00001000;
			break ;
		case 6: TCN_raddr=TCN_raddr| 0b00001010;
				TCN_waddr=TCN_waddr| 0b00001010;
			break ;
		case 7: TCN_raddr=TCN_raddr| 0b00001100;
				TCN_waddr=TCN_waddr| 0b00001100;
			break ;
		case 8: TCN_raddr=TCN_raddr| 0b00001110;
				TCN_waddr=TCN_waddr| 0b00001110;
			break ;
		default: TCN_raddr=TCN_raddr ;
				TCN_waddr=TCN_waddr ;
			break ;
	}

}

void res_Conf2(int addr)
{
	
	I2Cdev_sel(addr);
	
	//TCN_addr=0b10010000;
	conf_pointer=0b00000001;
	TCN_Conf=0b01100000;
		
	TWCR = (1<<TWINT) | (1<<TWSTA) | (1<<TWEN); // send START
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=START)
		error("START");

	TWDR = TCN_waddr;			  //SLA2_W;	//load SLA_W
	TWCR = (1<<TWINT)|(1<<TWEN); //start transmission of address
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=MT_SLA_ACK)
		error("MT_SLA_ACK");
	
	TWDR=conf_pointer;			//send config pointer
	TWCR=(1<<TWINT) | (1<<TWEN);
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=MT_DATA_ACK)
		error("MT_DATA_ACK");
	
	TWDR=TCN_Conf;				//send settings
	TWCR=(1<<TWINT) | (1<<TWEN);
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=MT_DATA_ACK)
		error("MT_DATA_ACK");
	
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
	
}



uint16_t I2C_Datareq2(int addr)
{
	Ta_pointer=0x00;

	I2Cdev_sel(addr);

	TWCR = (1<<TWINT) | (1<<TWSTA) | (1<<TWEN); // send START
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=START)
		error("START");

	TWDR = 	TCN_waddr;				//SLA2_W;	load SLA_W
	TWCR =(1<<TWINT) | (1<<TWEN) ; //start transmission of address
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=MT_SLA_ACK)
		error("MT_SLA_ACK");
	
	TWDR=Ta_pointer;				//send Ta pointer
	TWCR=(1<<TWINT)|(1<<TWEN);
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=MT_DATA_ACK)
		error("MT_DATA_ACK");
	
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);

//	int ij;
//	for(ij=0;ij!=60000;ij++);

	TWCR = (1<<TWINT) | (1<<TWSTA) | (1<<TWEN); // send START
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=START)
		error("START");

	TWDR = TCN_raddr;				//SLA2_R;	//load SLA_R
	TWCR = (1<<TWINT) | (1<<TWEN) ; //start transmission of address
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=MR_SLA_ACK)
		error("MR_SLA_ACK");
	
	
	TWCR = (1<<TWINT) | (1<<TWEN) ;
	while(!(TWCR & (1<<TWINT)));
	temph=TWDR<<8;					//receive temperature high byte
	if ((TWSR & 0xF8)!=MR_DATA_ACK)
		error("MR_DATA_ACK");
	
	
	TWCR = (1<<TWINT) | (1<<TWEN) ;
	while(!(TWCR & (1<<TWINT)));
	templ=TWDR;						//receive temperature low byte
	if ((TWSR & 0xF8)!=MR_DATA_NACK)
		error("MR_DATA_NACK");
	
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
	
	temp=temph | templ;
	return temp;

//	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
	
}