void TCN_Config(void)
{
	TWBR=0x80;		//set frequency to 375 kHZ
	TWCR=0x44;
	//TWSR=TWSR & 0xFC;
}


void res_Conf2(void)
{
	//TCN_addr=0b10010000;
	conf_pointer=0b00000001;
	TCN_Conf=0b01100000;
		
	TWCR = (1<<TWINT) | (1<<TWSTA) | (1<<TWEN); // send START
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=START)
		error("START");

	TWDR = SLA2_W;	//load SLA_W
	TWCR = (1<<TWINT)|(1<<TWEN); //start transmission of address
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=MT_SLA_ACK)
		error("MT_SLA_ACK");
	
	TWDR=conf_pointer;			//send config pointer
	TWCR=(1<<TWINT) | (1<<TWEN);
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=MT_DATA_ACK)
		error("MT_DATA_ACK");
	
	TWDR=TCN_Conf;				//send settings
	TWCR=(1<<TWINT) | (1<<TWEN);
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=MT_DATA_ACK)
		error("MT_DATA_ACK");
	
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
	
}


uint16_t I2C_Datareq2(void)
{
	Ta_pointer=0x00;

	TWCR = (1<<TWINT) | (1<<TWSTA) | (1<<TWEN); // send START
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=START)
		error("START");

	TWDR = SLA2_W;	//load SLA_W
	TWCR =(1<<TWINT) | (1<<TWEN) ; //start transmission of address
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=MT_SLA_ACK)
		error("MT_SLA_ACK");
	
	TWDR=Ta_pointer;				//send Ta pointer
	TWCR=(1<<TWINT)|(1<<TWEN);
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=MT_DATA_ACK)
		error("MT_DATA_ACK");
	
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);

//	int ij;
//	for(ij=0;ij!=60000;ij++);

	TWCR = (1<<TWINT) | (1<<TWSTA) | (1<<TWEN); // send START
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=START)
		error("START");

	TWDR = SLA2_R;	//load SLA_R
	TWCR = (1<<TWINT) | (1<<TWEN) ; //start transmission of address
	while(!(TWCR & (1<<TWINT)));
	if ((TWSR & 0xF8)!=MR_SLA_ACK)
		error("MR_SLA_ACK");
	
	
/*	TWCR = (1<<TWINT) | (1<<TWEN) ;
	while(!(TWCR & (1<<TWINT)));
	temph=TWDR<<8;					//receive temperature high byte
	if ((TWSR & 0xF8)!=MR_DATA_ACK)
		error("MR_DATA_ACK");
*/


	TWCR = (1<<TWINT) | (1<<TWEN) ;
	while(!(TWCR & (1<<TWINT)));
	temph=TWDR<<8;					//receive temperature high byte
	if ((TWSR & 0xF8)!=MR_DATA_ACK)
		error("MR_DATA_ACK");
	
	
	TWCR = (1<<TWINT) | (1<<TWEN) ;
	while(!(TWCR & (1<<TWINT)));
	templ=TWDR;						//receive temperature low byte
	if ((TWSR & 0xF8)!=MR_DATA_NACK)
		error("MR_DATA_NACK");
	
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
	
	temp=temph | templ;
	return temp;

//	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
	
}

//	tempcalc2=I2C_Datareq2()*0.0625/16;
//	Send_SMS(tempcalc2);
		 
//	printf("Temperature= %f C\n",tempcalc);	 

void error(char * err)
{
//printf("Error:%s\n",err);
er=er+1;
}

**************************
	tempwr = I2C_Datareq2(3)*0.0625/16;
	a=tempwr;	
	sprintf(ctemp,"Temperature is %d",a);
/*	if (!Send_SMStemp(tempwr))	//sending temperature from I2C sensor
										return 0;*/